VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "International"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"Locales"
Option Explicit

Private mvLocales As Locales
Private mvSysDefLCID As Long
Private mvSysDefLocale As Locale

Private Declare Function GetSystemDefaultLCID Lib "kernel32" () As Long
Private Declare Function IsValidLocale Lib "kernel32" (ByVal Locale As Long, ByVal dwFlags As Long) As Long
Private Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" (ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String, ByVal cchData As Long) As Long

Private Const LCID_INSTALLED = 1
Private Const LCID_SUPPORTED = 2
Private Const LOCALE_ICALENDARTYPE = &H1009
Private Const LOCALE_IOPTIONALCALENDAR = &H100B

Public Property Get Locales() As Locales
Set Locales = mvLocales

End Property


Private Sub psAddLocale(PRLang As Long, SubLang As Long)
' Create a new locale and add it to the collection if it is a valid one
' A locale will not be valid if either the release of windows does
' not support it, or it is not installed by the system

Dim lX As Locale
Dim tLCID As Long, vLoc As Boolean, lStr As String
' Create LCID for this setting
tLCID = pfMAKELCID(PRLang, SubLang)
If tLCID = 1028 Or tLCID = 1029 Or tLCID = 2052 Or tLCID = 1066 Then
    ' Czech base locales - there are a few problems with these specific ones that
    ' I'm not going to deal with in this version
    ' Also Vietnamese
    Exit Sub
End If
' Check it's valid
vLoc = False
If IsValidLocale(tLCID, LCID_INSTALLED) = 1 Then vLoc = True   ' Invalid locale
' Check locale uses the gregorian calendar - I'm not going to deal with anything that doesn't
lStr = String(255, Chr(0))
If vLoc Then
    GetLocaleInfo tLCID, LOCALE_ICALENDARTYPE, lStr, 255
    lStr = Left(lStr, InStr(1, lStr, Chr(0)) - 1)
    If Len(lStr) > 0 Then
        If CInt(lStr) > 2 Then
        ' Primary calendar is Japanese Year of the Emperor, Year of Taiwan Region or Tangun Era
        ' I'm not going to deal with these in this version
        vLoc = False
        End If
    End If
End If
' Currently ignoring secondary calendars.

On Error Resume Next
If vLoc Then
    ' Locale appears to be valid
    Set lX = New Locale
    lX.SetLanuage PRLang, SubLang
    If lX.AbbrevLangName = "" Then Exit Sub
    mvLocales.AddObj lX
    If lX.LCID = mvSysDefLCID Then Set mvSysDefLocale = lX
End If
End Sub

Private Function pfMAKELCID(PLang As Long, SLang As Long) As Long
Dim tX As Long
tX = SLang * 2 ^ 10
tX = tX Or PLang
pfMAKELCID = tX
End Function

Public Property Get SystemDefault() As Locale
Set SystemDefault = mvSysDefLocale
End Property


Private Sub Class_Terminate()
Set mvLocales = Nothing
Set mvSysDefLocale = Nothing
Debug.Print "Int Destroyed"
End Sub




Private Sub Class_Initialize()
Set mvLocales = New Locales
' Get system default lcid
mvSysDefLCID = GetSystemDefaultLCID
' add all available locales
Dim i As Long, j As Long
' Bit of a fudge here
' Add the first 100 Primary languages and the first 50 sublanguages of each
' Should be OK since there are only about 40 supported primaries and
' the largest number of sublanguages is about seven
For i = 0 To 100
    For j = 0 To 20
        psAddLocale i, j
    Next
Next
End Sub


